import string

# input functions (with input loop)

import execute

class InputKeyCommandContext:
	def __init__(self):
		self.result = None

	def getcommandcontexts(self):
		return [InputKeyCommandContext]
	
execute.registercontext(InputKeyCommandContext, 'inputascii')

class InputKeyExecContext(execute.ExecutionContext):
	def __init__(self, par, con):
		execute.ExecutionContext.__init__(self, par)
		self.cmdcontext = con

	def getbindcontexts(self):
		ls = [self.cmdcontext, execute.globalcontext]
		return ls

	def undefinedkey(self, keylist):
		st = string.join(map(command.keyname, keylist))
		raise command.StatusBeepWarning(st+' is not an encodable keystroke')

def input_ascii(cmd):
	con = InputKeyCommandContext()
	exex = InputKeyExecContext(cmd.executor, con)
	while 1:
		try:
			screen.inputloop(exex)
		except command.DoneException:
			return con.result

def input_ascii_arg(cmd, argnum=1):
	if (argnum <= cmd.countargs()):
		return cmd.getarg(argnum)
	return input_ascii(cmd)

def input_choice(cmd, prompt='', opts={}):
	con = InputKeyCommandContext()
	exex = InputKeyExecContext(cmd.executor, con)
	
	minibuf.activate(prompt)
	exex.savedfocus = window.focuswin
	window.changefocus(-1)
	
	try:
		while 1:
			try:
				screen.inputloop(exex)
			except command.DoneException:
				key = chr(con.result)
				if opts.has_key(key):
					return opts[key]
				raise command.StatusBeepWarning(key+' is not a valid option')
				
	finally:
		minibuf.deactivate()
		window.changefocus(exex.savedfocus)
		status.post('')

def input_choice_arg(cmd, argnum=1, prompt='', opts={}):
	if (argnum <= cmd.countargs()):
		return opts[cmd.getarg(argnum)]
	return input_choice(cmd, prompt, opts)

### should stay in until y or n is entered
def input_yesorno(cmd, prompt=''):
	res = input_choice(cmd, prompt+' (y or n) ', {'y':1, 'n':0})
	return res	

class InputSequenceExecContext(execute.ExecutionContext):
	def __init__(self, par):
		execute.ExecutionContext.__init__(self, par)
		self.result = None

	def perform(self, res, con, resargs, keylist):
		self.result = (res, con, resargs, keylist)
		raise command.DoneException

def input_cmdsequence(cmd):
	exex = InputSequenceExecContext(cmd.executor)
	try:
		while 1:
			try:
				screen.inputloop(exex)
			except command.DoneException:
				return exex.result
	finally:
		status.post('')

### arg
			
# late imports
import command
import window
import status
import screen
import minibuf

class InputKeyAccept(command.Command):
	"""Accept a keystroke.
	"""
	name = "input-key-accept"
	context = 'inputascii'
	def call(self, con):
		arg = self.getarg()
		con.result = arg
		raise command.DoneException

command.register([InputKeyAccept])

for (key, keyname) in command.typeablerange:
	command.bind("input-key-accept", keyname, key)
