import sys
import os
import string
import signal
import traceback
import curses

stdscr = None

def registration():
	# sigh, ugliness
	log.register_buf_finder(textbuffer.getbyname)
	window.setdefaultbuffer(textbuffer.TextBuffer)

def main(scr):
	global stdscr
	stdscr = scr
	
	curses.raw()
	curses.nonl()

	status.init(stdscr)
	window.init(stdscr)
	
	exex = execute.ExecutionContext(None)

	status.post('Welcome to Umics')

	while 1:
		try:
			inputloop(exex)
		except command.CancelException:
			status.post("Cancel")
			curses.beep()
		except command.QuitException:
			status.clearforquit()
			return
		except command.AbortException:
			raise
		except Exception:
			###raise
			# maybe re-raise if we get N errors without actually blocking for input?
			# maybe have a command-line option for re-raise?
			(typ, val, tb) = sys.exc_info()
			biglist = traceback.format_exception(typ, val, tb)
			errstr = traceback.format_exception_only(typ, val)
			tb = None
			val = None
			typ = None
			biglist = string.join(biglist, '')
			errstr = string.strip(errstr[-1])
			log.clear('*backtrace*')
			log.lognoshow(biglist, '*backtrace*')
			status.post(errstr)
			curses.beep()

def inputloop(exex):	
		
	while 1:
		ls = exex.getbindcontexts()
		bindlist = command.contextstobindings(ls)

		keylist = ()
		res = command.CommandIncomplete

		while (res == command.CommandIncomplete):

			window.refresh()
			status.refresh()
			curses.doupdate()
			key = status.getkey()

			keylist = keylist + (key,)
			
			(res, con, resargs) = command.acceptkey(bindlist, keylist)

		if (res == None):
			exex.undefinedkey(keylist)
			continue

		if (exex.perform != None):
			exex.perform(res, con, resargs, keylist)
			continue

		### continue
		cmd = res(exex, resargs)
		try:
			assert isinstance(con, cmd.context)
			assert (cmd.executor == exex)
			cmd.call(con)
		except command.StatusWarning, ex:
			if (len(ex.args) > 0):
				st = ex.args[0]
				if (st != None):
					status.post(st)
			if (isinstance(ex, command.StatusBeepWarning)):
				curses.beep()


# late imports
import log
import status
import minibuf
import execute
import window
import buffer
import textbuffer
import selbuffer
import command

# and command sets
import cmd_general 
import cmd_command
import cmd_buffer
import cmd_textbuffer
import cmd_window
import cmd_textwindow
import cmd_selwindow
import cmd_help
import cmd_debug ###
