import string
import curses

import window

class SelWindow(window.Window):
	def __init__(self):
		self.dirtydata = 1
		self.dirtyview = 1
		self.dirtyfocus = 1   ### lame mechanism, change to watcher
		self.numcols = None
		self.colwidth = None
		self.layout = None
		self.promptlayout = None
		self.selection = 0
		self.seldrawn = None
		self.scrollline = 0

	def getcommandcontexts(self):
		return [SelWindow] + window.Window.getcommandcontexts(self)

	def reinit(self):
		self.dirtydata = 1
		self.numcols = None
		self.colwidth = None
		self.layout = None
		self.promptlayout = None

	def see_change(self, obj, sig, detail):
		if (sig == watcher.SIG_DATA):
			self.dirtydata = 1
			self.numcols = None
			self.colwidth = None
			self.layout = None
			self.promptlayout = None
			self.selection = 0
			self.seldrawn = None
			self.scrollline = 0

	def refresh(self):
		if (self.dirtydata):
			self.dirtydata = 0
			self.dirtyview = 1
			self.layout_text()

		headlines = len(self.promptlayout)
		selline = self.selection // self.numcols
		if ((selline < self.scrollline - headlines)
			or (selline >= (self.height-1) + self.scrollline - headlines)):
			self.scrollline = selline - ((self.height-2)//2) + headlines
			self.scrollline = max(0, self.scrollline)
			self.dirtyview = 1
			
		if (self.dirtyview):
			self.dirtyview = 0
			self.dirtyfocus = 0

			if (self == window.getfocus()):
				self.seldrawn = self.selection
			else:
				self.seldrawn = None
			
			self.body.erase()

			for ix in range(self.height-1):
				lx = ix + self.scrollline - headlines
				if (lx < 0):
					self.body.addnstr(ix, 0,
						self.promptlayout[lx+headlines], window.scrwidth)
				else:
					for jx in range(self.numcols):
						ent = lx * self.numcols + jx
						if (ent >= len(self.layout)):
							break
						if (ent == self.seldrawn):
							attr = curses.A_REVERSE
						else:
							attr = 0
						self.body.addnstr(ix, jx*self.colwidth,
							self.layout[ent], self.colwidth, attr)

		olddrawn = self.seldrawn
		if (self == window.getfocus()):
			self.seldrawn = self.selection
		else:
			self.seldrawn = None
		if (olddrawn != self.seldrawn):
			self.dirtyfocus = 1

		if (self.dirtyfocus):
			self.dirtyfocus = 0
			
			if (olddrawn != None and olddrawn < len(self.layout)):
				attr = 0
				row = (olddrawn // self.numcols) - self.scrollline + headlines
				col = olddrawn % self.numcols
				self.body.addnstr(row, col*self.colwidth,
					self.layout[olddrawn], self.colwidth, attr)
			if (self.seldrawn != None and self.seldrawn < len(self.layout)):
				attr = curses.A_REVERSE
				row = (self.seldrawn // self.numcols) - self.scrollline + headlines
				col = self.seldrawn % self.numcols
				self.body.addnstr(row, col*self.colwidth,
					self.layout[self.seldrawn], self.colwidth, attr)
				

	def layout_text(self):
		prls = string.split(self.data.prompt, '\n')
		self.promptlayout = map(
			lambda lin: string.join(map(text.displaychar.__getitem__, map(ord, lin)), ''),
			prls)

		self.layout = map(
			lambda lin: string.join(map(text.displaychar.__getitem__, map(ord, lin)), ''),
			self.data.body)
		if (len(self.layout) == 0):
			self.colwidth = 1
			self.numcols = 1
			return

		laylen = map(len, self.layout)
		maxlen = max(laylen)+1
		self.numcols = max(1, (window.scrwidth // maxlen))
		self.numcols = min(8, self.numcols)
		self.colwidth = (window.scrwidth // self.numcols)

import log
import watcher
import text
import execute

execute.registercontext(SelWindow, 'selwindow')

